#include <Application.h>
#include <InterfaceKit.h>
#include <StorageKit.h>
#include <TrackerAddon.h>

void process_refs(entry_ref dir_ref, BMessage *msg, void *)
{
  int refs;
  ssize_t len;
  int i;
  char Linkpath[B_PATH_NAME_LENGTH];
  BSymLink Link;
  BPath path;
  entry_ref file_ref;
  BEntry entry(&dir_ref);
  BMessage message, reply;
  entry_ref link_ref;

  entry.GetPath(&path);
  for (refs=0;msg->FindRef("refs", refs, &file_ref) == B_NO_ERROR;refs++) {
    entry.SetTo(&file_ref);
    entry.GetPath(&path);
    BSymLink Link(path.Path());
    len = Link.ReadLink(Linkpath,B_PATH_NAME_LENGTH);
    if ( ( len>0 ) & (Link.IsAbsolute()==true ) ) {
      Linkpath[len] = 0;
      for ( i = len-1 ; ( Linkpath[i] != 0x2F ) & ( i>=0 ) ; i-- );
      if ( i==0 ) {
        Linkpath[i+1] = 0;
      } else {
        Linkpath[i] = 0;
      };
      BEntry linkEntry(Linkpath);
      linkEntry.GetRef(&link_ref);
      message.what = B_REFS_RECEIVED;
      message.AddRef("refs",&link_ref);
      BMessenger("application/x-vnd.Be-TRAK").SendMessage(&message, &reply);
    };
  };
}

main()
{
  new BApplication("application/x-momoziro.BeTarget");
  (new BAlert("", "BeTarget Release1\nシンボリックリンクのリンク先フォルダを開く Tracker Add-on です。 /boot/home/config/add-ons/Trackerに置いてご利用ください。\n\n1999 momoziro研究所\n  http://www.mars.dti.ne.jp/~momoziro\n  mailto:momoziro@mars.dti.ne.jp", "OK"))->Go();
  delete be_app;
}
